// Michael J. Wilson
// Music 256a Fall 2010
// Homework #3

#include "WaterfallBuffer.h"

WaterfallBuffer::~WaterfallBuffer()
{
    for (unsigned int i = 0; i < m_buffers.size(); i++)
    {
        delete m_buffers[i];
    }    
}

WaterfallBuffer::WaterfallBuffer(unsigned int size, unsigned int num_waterfalls)
{
    for (unsigned int i = 0; i < num_waterfalls; i++)
    {
        m_buffers.push_back(new std::vector<float>(size, 0.0));
    }

    last_buffer = 0;
}

unsigned int WaterfallBuffer::num_waterfalls()
{
    return m_buffers.size();
}

std::vector<float>* WaterfallBuffer::get_buffer(int index)
{
    size_t result_index = m_buffers.size() + last_buffer - index - 1;
    result_index %= m_buffers.size();
    return m_buffers[result_index];
}

std::vector<float>* WaterfallBuffer::get_next_write_buffer()
{
    std::vector<float>* result = m_buffers[last_buffer];
    last_buffer++;
    last_buffer %= m_buffers.size();
    return result;
}
