// Michael J. Wilson
// Music 256a Fall 2010
// Homework #3

#ifndef __WATERFALL_BUFFER_H__
#define __WATERFALL_BUFFER_H__

#include <vector>

/// Implements a buffer system which efficiently has multiple buffers
/// of the same length.  Buffers may be requested in order, and may be
/// filled in a first-in first-out fashon without reallocations.
class WaterfallBuffer
{
public:
    ~WaterfallBuffer();
    WaterfallBuffer(unsigned int size, unsigned int num_waterfalls);

    /// Get buffers of the specified index, respecting the circular
    /// nature of this datastructure.  That is, 0 corresponds to the
    /// most recently inserted buffer and N-1 corresponds to the
    /// buffer that was inserted the longest time ago
    std::vector<float>* get_buffer(int index);

    /// Get the next buffer that may be written to.  Also increments
    /// the write index.
    std::vector<float>* get_next_write_buffer();

    // Get the number of waterfalls
    unsigned int num_waterfalls();

private:
    std::vector<std::vector<float>*> m_buffers;
    size_t last_buffer;
};

#endif
